// =====================================================================
/*!
//
//  \file TMatrixElement.hh
//  \brief This file contains the TMatrixElement class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TMatrixElement.hh,v 1.6 2004/03/07 10:30:27 goiwai Exp $
//  $Name: CLDAQ-1-14-06 $
//  $Log: TMatrixElement.hh,v $
//  Revision 1.6  2004/03/07 10:30:27  goiwai
//  ROOTに組みこむためのおまじないマクロを埋めこみました。
//  全てにおいて完全に動作するわけではありません。
//
//  Revision 1.5  2004/01/19 21:09:38  goiwai
//  プリプロセッサの接頭辞をCLDAQ__に変更しました.
//
//  Revision 1.4  2003/11/03 08:35:10  goiwai
//  Doxygen用のタグとコメントをうちこんでいく試みを開始しました.
//
//  Revision 1.3  2003/10/06 17:02:36  goiwai
//  *** empty log message ***
//
//  Revision 1.2  2003/07/30 16:17:11  goiwai
//  ファイルにコミットログをつけることにしました.
//
*/
// =====================================================================
#ifndef CLDAQ__TMATRIXELEMENT_HH
#define CLDAQ__TMATRIXELEMENT_HH

#include "Tglobals.h"
#include "TDataMultiplicity.hh"


/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TMatrixElement
// \brief This is the TMatrixElement class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TMatrixElement class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup AnalysisCategory
*/
class TMatrixElement
  : public TDataMultiplicity
{

  private:
    Tstring theMatrixID;
    Tobject_t theObjectType;

  public:
    TMatrixElement( const Tstring& idstr = "", Tobject_t objecttype = tObjectUnknown, Tint ndata = 0, Tint ntuple = 0 );
    TMatrixElement( const TMatrixElement& right );
    ~TMatrixElement();

  public:
    const TMatrixElement& operator=( const TMatrixElement& right );
    Tbool operator==( const TMatrixElement& right ) const;
    Tbool operator!=( const TMatrixElement& right ) const;

  public:
    const Tstring& GetMatrixID() const;
    Tstring& GetMatrixID();
    Tvoid SetMatrixID( const Tstring& id );
    Tobject_t GetObjectType() const;
    Tvoid SetObjectType( Tobject_t objecttype );

  public:
    Tint GetNumberOfTuples() const;
    Tint GetNumberOfEvents() const;

#ifdef __CLDAQ_ROOT_DLL
    ClassDef(TMatrixElement,0)
#endif

};

inline const Tstring& TMatrixElement::GetMatrixID() const
{
  return theMatrixID;
}

inline Tstring& TMatrixElement::GetMatrixID()
{
  return theMatrixID;
}

inline Tvoid TMatrixElement::SetMatrixID( const Tstring& id )
{
  theMatrixID = id;
  return;
}

inline Tint TMatrixElement::GetNumberOfTuples() const
{
  return num_col();
}

inline Tint TMatrixElement::GetNumberOfEvents() const
{
  return num_row();
}

inline Tobject_t TMatrixElement::GetObjectType() const
{
  return theObjectType;
}

inline Tvoid TMatrixElement::SetObjectType( Tobject_t objecttype )
{
  theObjectType = objecttype;
  return;
}

#endif
